import axios, { AxiosRequestConfig } from 'axios';
import jwt_decode from 'jwt-decode';
import { store } from '../store';

export const API = (
  method: string,
  url: string,
  data: {} | null = null,
  headers: any | null = null
) => {
  const API = axios.create({
    baseURL: process.env.REACT_APP_BASE_URL
  });

  API.interceptors.request.use(
    async config => {
      const {} = store.getState();

      if (
        config.url !== '' &&
        store.getState() &&
        config.headers?.authorization
      ) {
        const { exp }: { exp: number } = jwt_decode('TOKEN FROM STORE');

        if (exp * 1000 - 30000 < Date.now()) {
          // await store.dispatch();

          const {} = store.getState();

          config.headers.authorization = `Bearer ${'TOKEN FROM STORE'}`;
        }
      }

      return config;
    },
    error => {
      return Promise.reject(error);
    },
  );

  return API.request({ method, url, data, headers } as AxiosRequestConfig);
};

/* CONTROLLER_EXPORTS */
